.text
.globl Racunaj
Racunaj:                             # long long Racunaj(long long *A, long long *B, char *operacija, int *greska);
        pushl   %ebp
        movl    %esp, %ebp
        pushl   %ebx                 # cuvanje registara
        pushl   %esi
        pushl   %edi
        movl    20(%ebp), %ebx        	# 4 par. adresa greske
        movl    16(%ebp), %ecx          # 3 par. adresa operacije 
        movl    12(%ebp), %esi          # 2 par. adresa drugog op.
        movl    8(%ebp), %edi           # 1 par. adresa prvog op.
        movl    $0, (%ebx)              # greska=0
        movb    (%ecx), %cl
        cmpb    $'+', %cl
        je      zbirRacunaj
        cmpb    $'-', %cl
        je      razlikaRacunaj
        cmpb    $'*', %cl
        je      proizvodRacunaj
        movl    $1, (%ebx)                # nepoznata operacija, greska=1
krajRacunaj:
        popl    %edi                      # vracanje registara
        popl    %esi
        popl    %ebx
        movl    %ebp, %esp
        popl    %ebp
        ret
proizvodRacunaj:
        movl    4(%esi), %ecx                # visi delovi
        movl    4(%edi), %eax
        andl         %eax, %eax              # visiA==0?
        jz      daljeProizvodRacunaj
        andl    %ecx, %ecx                   # visiB==0?
        jnz     prekoracenjeRacunaj          # ako su oba visa dela razlicita od nule -> prekoracenje
daljeProizvodRacunaj:
        imull   (%esi), %eax                 # niziB * visiA
        jo      prekoracenjeRacunaj
        imull   (%edi), %ecx                 # niziA * visiB
        jo      prekoracenjeRacunaj
        addl    %eax, %ecx                   # dobijeno saberi
        jo      prekoracenjeRacunaj
        movl    (%edi), %eax
        mull    (%esi)                       # pomnozi nize delove
        test    %edx, %edx
        js      prekoracenjeRacunaj
        addl    %ecx,%edx                    # saberi vise delove -> proizvod u edx:eax
        jo      prekoracenjeRacunaj
        jmp     krajRacunaj
razlikaRacunaj:
        movl    (%edi), %eax                 # oduzimanje
        movl    4(%edi), %edx
        subl    (%esi), %eax
        sbbl    4(%esi), %edx                # razlika u edx:eax
        jo      prekoracenjeRacunaj
        jmp     krajRacunaj
zbirRacunaj:
        movl    (%esi), %eax                 # sabiranje
        movl    4(%esi), %edx
        addl    (%edi), %eax
        adcl    4(%edi), %edx                # zbir u edx:eax
        jo      prekoracenjeRacunaj
        jmp     krajRacunaj
prekoracenjeRacunaj:
        movl    $-1, (%ebx)                  # prekoracenje, greska=-1
        jmp     krajRacunaj

