.text
.globl DodajMnozi
DodajMnozi:			# int DodajMnozi(long long *A, unsigned N);
        pushl   %ebp
        movl    %esp, %ebp
        pushl   %edi			#sacuvaj registre
        pushl   %esi
        pushl   %ebx
        subl    $12, %esp		#prostor za lok. promenljive: i (brojac petlje), br_uopsegu (brojac el. u opsegu), pokazivac na niz
        xorl    %edx, %edx
        xorl    %ecx, %ecx
        movl    12(%ebp), %ebx		# 2 par. br elemenata N
        movl    8(%ebp), %eax		# 1 par. pokazivac na niz *A
        movl    $0, -16(%ebp)		# br_uopsegu=0
        testl   %ebx, %ebx		# da li je br elemenata N==0 ?
        je      krajDodajMnozi		# ako jeste, niz je prazan -> kraj
        movl    %edx, -20(%ebp)		# brojac petlje i=0
        movl    %eax, -24(%ebp) 	# inicijalizuj pokazivac 
        jmp     proveraIntervalaDodajMnozi

prekoracenjeDodajMnozi:
        movl	$-1, %ecx		# prekoracenje -> vrati -1
        jmp krajDodajMnozi
proveraNiziDodajMnozi:			# nastavak provere
        jb      uIntervaluDodajMnozi
        cmpl    $0x7D32340E, %esi
        ja      vanIntervalaDodajMnozi
uIntervaluDodajMnozi:			# element je u intervalu -> pomnozi ga sa 10
        movl    $10, %eax
        mull    %ecx			#pomnozi nizi deo
        imull   $10, %ebx, %esi		#pomnozi visi deo i smesti ga u %esi
        addl    $1, -16(%ebp)		#uvecaj br_uopsegu
        movl    %eax, %ecx
        movl    -24(%ebp), %eax		# pokazivac na niz
        leal    (%esi,%edx), %ebx	# zbir visih delova u ebx
        movl    -20(%ebp), %edx
        movl    %ecx, (%eax,%edx,8)	# upisi element nazad u niz
        movl	%ebx, 4(%eax,%edx,8)
        incl	%edx			# uvecaj indeks i
        movl	%edx, -20(%ebp)
        cmpl	%edx, 12(%ebp)		# da li je stigao do N?
        jbe     krajPetljeDodajMnozi	# ako jeste -> zavrsi petlju

proveraIntervalaDodajMnozi:		# da li je element niza u intervalu (-123456789000, 123456789000) tj (-1CBE991A07,1CBE991A07)
        movl    -20(%ebp), %eax		# brojac petlje i je indeks
        movl    -24(%ebp), %edx		# pokazivac
        movl    (%edx,%eax,8), %ecx	# nizi deo
        movl    4(%edx,%eax,8), %ebx	# visi deo
        movl    %ecx, %esi
        addl    $0xBE991A07, %esi	# element saberi sa 0x1CBE991A07
        movl    %ebx, %edi
        adcl    $0x1C, %edi
        cmpl    $0x39, %edi		# ako je zbir > od 2*0x1CBE991A07-2=0x397D32340E ili <= 0 -> van opsega
        jbe     proveraNiziDodajMnozi	# ako je visi deo manji, proveri i nizi

vanIntervalaDodajMnozi:                 # element je u intervalu -> dodaj mu 10000
        movl    -20(%ebp), %edx		# indeks niza i
        addl    $10000, %ecx
        movl    -24(%ebp), %eax		# pokazivac na pocetak niza
        adcl    $0, %ebx
        jo	prekoracenjeDodajMnozi
        movl    %ecx, (%eax,%edx,8)	# upisi element nazad u niz
        movl	%ebx, 4(%eax,%edx,8)
        incl	%edx			# uvecaj indeks i
        movl	%edx, -20(%ebp)
        cmpl	%edx, 12(%ebp)		# da li je stigao do N?
        ja	proveraIntervalaDodajMnozi
krajPetljeDodajMnozi:
        movl	-16(%ebp), %ecx
krajDodajMnozi:
        addl	$12, %esp		# oslobodi prostor za lok. promenljive
        movl	%ecx, %eax		# povratna vrednost
        popl	%ebx
        popl	%esi
        popl	%edi
        popl	%ebp
        ret

